package vsp.uloha437;

import cz.zcu.fav.kiv.jsim.JSimInvalidParametersException;
import cz.zcu.fav.kiv.jsim.JSimProcess;
import cz.zcu.fav.kiv.jsim.JSimSecurityException;
import cz.zcu.fav.kiv.jsim.JSimSimulation;
import cz.zcu.fav.kiv.jsim.JSimSimulationAlreadyTerminatedException;
import cz.zcu.fav.kiv.jsim.JSimSystem;
import cz.zcu.fav.kiv.jsim.JSimTooManyProcessesException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Generator pozadavku.<br/>
 * <br/>
 * Casove intervaly mezi vystupnimi pozadavky maji exponencialni rozdeleni.
 *
 * @author Jiri Kucera (kalwi@students.zcu.cz)
 */
public class Generator extends JSimProcess {

    private Junction out;
    private double lambda;
    private int counter;
    private int count;

    /**
     * Konstruktor tridy.
     * 
     * @param name Nazev objektu.
     * @param simulation Reference na objekt simulacniho modelu.
     * @param lambda Parametr exponencialniho rozdeleni doby mezi vstupnimi pozadavky.
     * @param count Pocet pozadavku, ktere budou vygenerovany.
     * @param out Vystupni prvek.
     * @throws JSimSimulationAlreadyTerminatedException
     * @throws JSimInvalidParametersException
     * @throws JSimTooManyProcessesException
     */
    public Generator(String name, JSimSimulation simulation, double lambda, int count, Junction out)
	    throws JSimSimulationAlreadyTerminatedException, JSimInvalidParametersException, JSimTooManyProcessesException {

	super(name, simulation);

	this.out = out;
	this.lambda = lambda;
	this.counter = 0;
	this.count = count;
    }

    /**
     * V nekonecne smycce:
     * - vygeneruje pozadavek
     * - posle jej na vystup
     * - ceka nahodnou dobu s exponencialnim rozdelenim
     */
    @Override
    public void life() {
	try {

	    while (counter < count) {
		Transaction tr = new Transaction(myParent);

		out.put(tr);

		hold(JSimSystem.negExp(lambda));

		counter++;
	    }

	} catch (JSimSecurityException ex) {
	    Logger.getLogger(Generator.class.getName()).log(Level.SEVERE, null, ex);
	} catch (JSimInvalidParametersException ex) {
	    Logger.getLogger(Generator.class.getName()).log(Level.SEVERE, null, ex);
	}
    }
}
